#include "stdafx.h"

int _tmain(int argc, TCHAR** argv)
{
	LPBYTE ptr = NULL;
	DWORD  size = 0;
	md5_state_t state;
	TCHAR fileName[MAX_PATH];
	TCHAR inputFileName[MAX_PATH];
	LPTSTR pFilePtr = NULL;
	LPTSTR inputFilePtr = NULL;
	unsigned char digest[16];
	unsigned char ch;
	unsigned char MASK = 0x0F;
	FILE* stream = NULL;

	if (argc==2)
	{
		inputFilePtr = argv[1];
	}
	else
	{
		if (argc == 1)
		{
			if (FileOpenDlg(inputFileName))
			{
				inputFilePtr = inputFileName;
			}
			else
			{
				return 1;
			}
		}
		else
		{
			return 1;
		}
	}
	_tprintf(_T("filename[%s]\n"), inputFilePtr);
	if (mapFile(inputFilePtr, ptr, size))
	{
		md5_init(&state);
		md5_append(&state, ptr, size);
		md5_finish(&state, digest);
		unmapFile(ptr);
		if (_tcsclen(inputFilePtr) == MAX_PATH - 1)
		{
			pFilePtr = inputFilePtr + 4;
		}
		else
		{
			pFilePtr = inputFilePtr;
		}
		_sntprintf(fileName, MAX_PATH - 1, _T("%s.md5"), pFilePtr);  
		if ((stream = _tfopen(fileName, _T("w")))!= NULL)
		{
			for (int i =0 ; i< 16; i ++)
			{  		
				ch = digest[i]>>4;
				fprintf(stream, "%X", ch);
				ch = digest[i] & MASK;
				fprintf(stream, "%X", ch);
			}
			printf("\n");
			fclose(stream);
		}
	}	
	return 0;
}